unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ident, StdCtrls, ColMemo, ircClient,scktcomp;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    ident1: Tident;
    Button3: TButton;
    Button4: TButton;
    irc1: TircClient;
    Edit2: TEdit;
    Button5: TButton;
    Button6: TButton;
    Edit3: TEdit;
    Button7: TButton;
    Label1: TLabel;
    sendto: TEdit;
    Button8: TButton;
    Memo1: TMemo;
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure irc1RawData(Sender: TircClient; RawData: string);
    procedure Button4Click(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure irc1Ping(Sender: TircClient; AutoReply: String; RawData: string);
    procedure irc1PrivateMsg(Sender: TircClient; From, shortfrom, priv,
      messages: String; RawData: string);
    procedure irc1ChannelMsg(Sender: TircClient; From, shortfrom, Chan,
      messages: String; RawData: string);
    procedure irc1JoinMsg(Sender: TircClient; From, shortfrom, chan: String;
      RawData: string);
    procedure irc1QuitMsg(Sender: TircClient; From, shortfrom, QuitMsg: String;
      RawData: string);
    procedure irc1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure irc1Connected(Sender: TObject; Socket: TCustomWinSocket);
    procedure irc1PartMsg(Sender: TircClient; From, shortfrom, chan,
      RawData: String);
    procedure irc1433(Sender: TircClient; NickInUse, RawData: String);
    procedure irc1332(Sender: TircClient; chan, topic, RawData: String);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure irc1NickChange(Sender: TircClient; OldNickLong, OldNickShort,
      NewNick, RawData: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button3Click(Sender: TObject);
begin
 ident1.watchport;
 irc1.connect;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    irc1.join(sendto.text);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 irc1.part(sendto.text);
end;

procedure TForm1.irc1RawData(Sender: TircClient; RawData: string);
begin
 memo1.lines.add('Raw> ' + Trimright(RawData));
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 irc1.SendRawMsg(edit1.text);
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
 memo1.lines.savetofile('d:\windows\desktop\irclog.txt');
end;

procedure TForm1.irc1Ping(Sender: TircClient; AutoReply: String; RawData: string);
begin
 memo1.lines.add(AutoReply);
end;

procedure TForm1.irc1PrivateMsg(Sender: TircClient; From, shortfrom, priv,
  messages: String; RawData: string);
begin
 memo1.lines.add('[' + priv + ']  <' + shortFrom + '> ' + messages);
 memo1.lines.add('Raw> ' + Trimright(RawData));
end;

procedure TForm1.irc1ChannelMsg(Sender: TircClient; From, shortfrom, Chan,
  messages: String; RawData: string);
begin
 memo1.lines.add('[' + Chan + ']  <' + shortFrom + '> ' + messages);
// memo1.lines.add('Raw> ' + Trimright(RawData));
end;

procedure TForm1.irc1JoinMsg(Sender: TircClient; From, shortfrom, chan: String;
  RawData: string);
begin
 memo1.lines.add('[JOIN] ' + From + ': ' + chan);
// memo1.lines.add('Raw> ' + Trimright(RawData));
end;

procedure TForm1.irc1QuitMsg(Sender: TircClient; From, shortfrom,
  QuitMsg: String; RawData: string);
begin
 memo1.lines.add('[QUIT] ' + From + ': ' + quitmsg);
// memo1.lines.add('Raw> ' + Trimright(RawData));
end;

procedure TForm1.irc1Error(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
 memo1.lines.add('Error Code> ' + intToStr(ErrorCode));
end;

procedure TForm1.irc1Connected(Sender: TObject; Socket: TCustomWinSocket);
begin
 memo1.lines.add('CONNECTED!');
end;

procedure TForm1.irc1PartMsg(Sender: TircClient; From, shortfrom, chan,
  RawData: String);
begin
 memo1.lines.add('[PART] ' + From + ': ' + chan);
end;

procedure TForm1.irc1433(Sender: TircClient; NickInUse, RawData: String);
begin
  irc1.ChangeNick(irc1.AltNickName);
end;

procedure TForm1.irc1332(Sender: TircClient; chan, topic, RawData: String);
begin
 memo1.lines.add('[TOPIC] ' + chan + ': ' + topic);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
edit3.text := irc1.LONGIPtoDottedIP(strtoint64(edit2.text));
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 edit3.text := IntToStr(irc1.DOTTEDIPtoLongIP(Pchar(edit2.text)));
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  irc1.SendPrivateMsg(sendto.text, Edit1.text);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  irc1.SendChannelMsg(sendto.text, Edit1.text);
end;

procedure TForm1.irc1NickChange(Sender: TircClient; OldNickLong,
  OldNickShort, NewNick, RawData: String);
begin
 memo1.lines.add('[OLD NICK Long version] ' + OldNickLong + ' [OLD NICK Short version] ' + OldNickShort + ' [NEW NICK] ' + NewNick);
end;

end.
